/******************************************************************************\
*	Form-Builder.js
*	Project : Geoportail-Shortcode
*	Date : 10/05/12
*	Auteur : geoWP
\******************************************************************************/

var mode="simple";
var layers_allowed = null;
var nb_simple_layers = 0;		
var layers_activate =  new Array();
var orthoName="Ortho Images";
var mapName="IGN Maps";

/*----------------------------------------------------------------------------*\
* function active_form
\*----------------------------------------------------------------------------*/
function active_form(LAYERS_ARRAY){
	if (gGEOPORTALRIGHTSMANAGEMENT.apiKey != '' )
	{
		LAYERS_ARRAY = LAYERS_ARRAY.split(/;/);
		LAYERS_ARRAY.pop(); // supprime la derniere case vide

		for (i=0; i<LAYERS_ARRAY.length; i++)
		{
			temp=LAYERS_ARRAY[i].split('|');
			layers_activate.push( temp[0] );
			layers_activate[ temp[0] ] =  new Array();
			layers_activate[ temp[0] ].push( temp[1]);
			layers_activate[ temp[0] ].push( temp[2]);
		}
	}
	layers_allowed = gGEOPORTALRIGHTSMANAGEMENT[gGEOPORTALRIGHTSMANAGEMENT.apiKey].allowedGeoportalLayers;
	var avancedTable = document.getElementById("avancedTable");
	var simpleTable = document.getElementById("simpleTable");
	for(i=0;i<layers_allowed.length;++i)
	{
		addLigne(layers_allowed[i],i,avancedTable);
	
		if(layers_allowed[i] == "GEOGRAPHICALGRIDSYSTEMS.MAPS:WMSC")
		{
			addLigne(mapName,"s_"+nb_simple_layers,simpleTable);
			nb_simple_layers++;
		}
		
		if(layers_allowed[i] == "ORTHOIMAGERY.ORTHOPHOTOS:WMSC")
		{
			addLigne(orthoName,"s_"+nb_simple_layers,simpleTable);
			nb_simple_layers++;
		}
	}
	if(layers_allowed.length!=0)
	{
		visibilite("no_api_key");
		visibilite("layer_simple");
	}
}
/*----------------------------------------------------------------------------*\
* function send_shortcode
\*----------------------------------------------------------------------------*/
function send_shortcode()
{
	var input_layers = "";
	var code = "[geoportail ";
	code += ' territory="' + document.getElementById("geomap_territory").value +'"';
	code += ' lat="' + document.getElementById("geomap_lat").value +'"';
	code += ' lon="' + document.getElementById("geomap_lon").value +'"';
	code += ' z="' + document.getElementById("geomap_z").value +'"';
	code += ' w="' + document.getElementById("geomap_w").value +'"';
	code += ' h="' + document.getElementById("geomap_h").value +'"';
	code += ' type="' + document.getElementById("geomap_type").value +'"';

	if(mode == "avanced")
	{
		for(i=0;i<layers_allowed.length;++i)
		{
			if(document.getElementById("layer_display_"+i).checked==true)
			{
			
				input_layers += document.getElementById("layer_name_"+i).value +"|";
				
				if(document.getElementById("layer_visibility_"+i).checked==true)
					input_layers +="on|"
				else
					input_layers +="off|"
				
				input_layers += document.getElementById("layer_opacity_"+i).value +";";
			}
		}
	}
	else
	{
		for(i=0;i<nb_simple_layers;++i)
		{
			if(document.getElementById("layer_display_s_"+i).checked==true)
			{
				if( document.getElementById("layer_name_s_"+i).value == orthoName)
					input_layers += "ORTHOIMAGERY.ORTHOPHOTOS:WMSC" +"|";
				
				if( document.getElementById("layer_name_s_"+i).value == mapName)
					input_layers += "GEOGRAPHICALGRIDSYSTEMS.MAPS:WMSC" +"|";
				
				if(document.getElementById("layer_visibility_s_"+i).checked==true)
					input_layers +="on|"
				else
					input_layers +="off|"
				
				input_layers +=   document.getElementById("layer_opacity_s_"+i).value +";";
			}
		}	
	}
	
	code += ' layers_array="' + input_layers +'"';

	var gpx_url = document.getElementById("geomap_gpx_url").value;
	var gpx_title = document.getElementById("geomap_gpx_title").value;
	if( gpx_url != '')
	{
		if( gpx_title == '')
			gpx_title = 'gpx_layer';
		
		code += ' gpx_array="' + gpx_url + ',' + gpx_title +'"';
	}

	var kml_url = document.getElementById("geomap_kml_url").value;
	var kml_title = document.getElementById("geomap_kml_title").value;
	if( kml_url != '')
	{
		if( kml_title == '')
			kml_title = 'kml_layer';
		
		code += ' kml_array="' + kml_url + ',' + kml_title +'"';
	} 

	code +=" /]";
	send_to_editor(code);
}
/*----------------------------------------------------------------------------*\
* function addLigne
\*----------------------------------------------------------------------------*/
function addLigne(name,num,table)
{

	var nameTemp = name;
	var isActivate = true;

	if(name == mapName)
		nameTemp = "GEOGRAPHICALGRIDSYSTEMS.MAPS:WMSC";
	if(name == orthoName)
		nameTemp = "ORTHOIMAGERY.ORTHOPHOTOS:WMSC";

	if( typeof(layers_activate[nameTemp]) == 'undefined')
		isActivate = false;

	var tbody = table.tBodies[0];

	var row = document.createElement("tr");

	var cell_1 = document.createElement("td");
		var input_1 = document.createElement("input");
		input_1.setAttribute("type","checkbox");
		input_1.setAttribute("id","layer_display_"+num);
	
	if (isActivate)
		input_1.setAttribute("checked",true);

	cell_1.appendChild(input_1);
	row.appendChild(cell_1);

	var cell_2 = document.createElement("td");
		var input_2 = document.createElement("input");
		input_2.setAttribute("type","text");
		input_2.setAttribute("disabled","disabled");
		input_2.setAttribute("style","width:300px;");
		input_2.setAttribute("id","layer_name_"+num);
		input_2.value=name;
	cell_2.appendChild(input_2);
	row.appendChild(cell_2);

	var cell_3 = document.createElement("td");
		var input_3 = document.createElement("input");
		input_3.setAttribute("type","checkbox");
		input_3.setAttribute("id","layer_visibility_"+num);
	
		if(isActivate)
		{
			if(layers_activate[nameTemp][0] == 'on')
			{
				input_3.setAttribute("checked",true);
			}
		}
		
	cell_3.appendChild(input_3);
	row.appendChild(cell_3);

	var cell_4 = document.createElement("td");
		var input_4 = document.createElement("input");
		input_4.setAttribute("type","number");
		input_4.setAttribute("min","0");
		input_4.setAttribute("max","1");
		input_4.setAttribute("step","0.1");
		input_4.setAttribute("style","width:50px;");
		input_4.setAttribute("id","layer_opacity_"+num);

		if(isActivate)
			input_4.value=layers_activate[nameTemp][1];
		else
			input_4.value=1;
	cell_4.appendChild(input_4);
	row.appendChild(cell_4);
	
	tbody.appendChild(row);
}
/*----------------------------------------------------------------------------*\
* function visibilite
\*----------------------------------------------------------------------------*/
function visibilite(thingId)
{
	var targetElement;
	targetElement = document.getElementById(thingId) ;
	if (targetElement.style.display == "none")
	{
		targetElement.style.display = "" ;
	} else {
		targetElement.style.display = "none" ;
	}
}
/*----------------------------------------------------------------------------*\
* function switchMode
\*----------------------------------------------------------------------------*/
function switchMode()
{
	visibilite('layer_simple');
	visibilite('layer_avanced');

	if (mode == "simple")
		mode="avanced";
	else
		mode="simple";
}
/*----------------------------------------------------------------------------*\
* function OnSubmitForm
\*----------------------------------------------------------------------------*/
function OnSubmitForm()
{
	var input_layers = document.getElementById("geomap_layers_array");

	if(mode == "avanced")
	{
		for(i=0;i<layers_allowed.length;++i)
		{
			if(document.getElementById("layer_display_"+i).checked==true)
			{
		
				input_layers.value += document.getElementById("layer_name_"+i).value +"|";
			
				if(document.getElementById("layer_visibility_"+i).checked==true)
					input_layers.value +="on|"
				else
					input_layers.value +="off|"
			
				input_layers.value += document.getElementById("layer_opacity_"+i).value +";";
			}
		}
	}
	else
	{
		for(i=0;i<nb_simple_layers;++i)
		{
			if(document.getElementById("layer_display_s_"+i).checked==true)
			{
				if( document.getElementById("layer_name_s_"+i).value == orthoName)
					input_layers.value += "ORTHOIMAGERY.ORTHOPHOTOS:WMSC" +"|";
			
				if( document.getElementById("layer_name_s_"+i).value == mapName)
					input_layers.value += "GEOGRAPHICALGRIDSYSTEMS.MAPS:WMSC" +"|";
			
				if(document.getElementById("layer_visibility_s_"+i).checked==true)
					input_layers.value +="on|"
				else
					input_layers.value +="off|"
			
				input_layers.value +=   document.getElementById("layer_opacity_s_"+i).value +";";
			}
		}	
	}
}
